=== src/lib/fcitx-utils/CMakeLists.txt ===
--- 
+++ 
@@ -110,6 +110,7 @@
     dbus/message_details.h
     dbus/servicewatcher.h
     dbus/matchrule.h
+    dbus/variant.h
     )
 
 ecm_setup_version(PROJECT
