=== src/ui/classic/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
 endif()
 
 if (ENABLE_DBUS)
+    set(CLASSICUI_SRCS ${CLASSICUI_SRCS} portalsettingmonitor.cpp)
     set(CLASSICUI_LIBS ${CLASSICUI_LIBS} Fcitx5::Module::DBus)
 endif()
