=== debian/changelog ===
fcitx5 (5.1.5-1deepin4) unstable; urgency=medium

  * feat: add Sogou to the default zh_CN input method list
    (linuxdeepin/developer-center#9901)

 -- zsien <quezhiyong@deepin.org>  Tue, 23 Jul 2024 19:05:36 +0800

fcitx5 (5.1.5-1deepin3) unstable; urgency=medium

  * fix #7815

 -- Mike Chen <chenke@deepin.org>  Fri, 12 Apr 2024 10:17:51 +0800

fcitx5 (5.1.5-1deepin2) unstable; urgency=medium

  * Add deepin patchs.
  * modify: change Breaks and Conflicts packages to support deepin(5.0.24+).

 -- xiangzelong <xiangzelong@deepin.org>  Thu, 30 Nov 2023 14:12:02 +0800

fcitx5 (5.1.5-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 08 Nov 2023 15:39:45 -0500

fcitx5 (5.1.4-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sun, 05 Nov 2023 13:22:25 -0500

fcitx5 (5.1.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/: Backport trunk patches.

 -- Boyuan Yang <byang@debian.org>  Sat, 04 Nov 2023 13:33:37 -0400

fcitx5 (5.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Nov 2023 14:07:08 -0400
