=== debian/control ===
--- 
+++ 
@@ -142,22 +142,22 @@
  ${shlibs:Depends},
 Breaks:
  fcitx5-module-dbus (<< 5.0.4-2),
- fcitx5-module-emoji (<< 5.0.20),
+ fcitx5-module-emoji (<< 5.0.23+),
  fcitx5-module-fcitx4 (<< 5.0.4-2),
  fcitx5-module-ibus (<< 5.0.4-2),
  fcitx5-module-kimpanel (<< 5.0.4-2),
- fcitx5-module-quickphrase (<< 5.0.20),
- fcitx5-module-wayland (<< 5.0.20),
- fcitx5-module-xorg (<< 5.0.20),
+ fcitx5-module-quickphrase (<< 5.0.23+),
+ fcitx5-module-wayland (<< 5.0.23+),
+ fcitx5-module-xorg (<< 5.0.23+),
 Replaces:
  fcitx5-module-dbus (<< 5.0.4-2),
- fcitx5-module-emoji (<< 5.0.20),
+ fcitx5-module-emoji (<< 5.0.23+),
  fcitx5-module-fcitx4 (<< 5.0.4-2),
  fcitx5-module-ibus (<< 5.0.4-2),
  fcitx5-module-kimpanel (<< 5.0.4-2),
- fcitx5-module-quickphrase (<< 5.0.20),
- fcitx5-module-wayland (<< 5.0.20),
- fcitx5-module-xorg (<< 5.0.20),
+ fcitx5-module-quickphrase (<< 5.0.23+),
+ fcitx5-module-wayland (<< 5.0.23+),
+ fcitx5-module-xorg (<< 5.0.23+),
 Provides:
  fcitx5-module-dbus,
  fcitx5-module-emoji,
